#define ANZAHL_DNA 100   //Anzahl der Individuen innerhalb einer Generation
#define ANZAHL_BESTE 10  //Anzahl der Besten einer Generation, die in die nchste Generation bernommen werden.

#define MUTATIONSRATE 500 //0..1000

class Evoopt
{
    private:
        Paramtest* paramtest;

        double fehler[ANZAHL_DNA];              //Merker fr die Fehler einer Generation
        int bestindex[ANZAHL_BESTE];           //Merker fr die Indices der ANZAHL_BESTE Besten einer Generation
        double bestfehler[ANZAHL_BESTE];        //Merker fr den Fehler bei den Besten.
        uint16_t psatz[ANZAHL_DNA][PANZ];       //Merker der Parameterstze einer Generation
        uint16_t psatzbest[ANZAHL_BESTE][PANZ]; //Merker der Parameterstze der Besten einer Generation
    public:
        Evoopt()
        {
            srand(0); //Die Berechnung von Pseudozufallszahlen mu auf dem Mikrocontroller womglich anders erfolgen.
        }

        void registriereParamtest(Paramtest* paramtest)
        {
            this->paramtest = paramtest;
        }

        int zufall(int von, int bis)
        {
            int x = rand();
            if(x<0)
                x=-x;
            return x%(bis-von+1)+von;        
        }

        void mutieren(uint16_t* p)
        {
            if(zufall(0,10)>5)              //Hier Mutationsniveau einstellen
                return; 
     
            int index = zufall(0,PANZ-1);  //Auswahl eines der Parameter
            int stelle = zufall(0,16);     //Zuflliges Bit bei uint16_t

            if( (p[index] & (1<<stelle)) > 0)
            {
                p[index] = p[index] & ~(1<<stelle);
            }     
            else
            {
                p[index] = p[index] | (1<<stelle);
            }
        }

        void rekombinieren(uint16_t* best1, uint16_t* best2, uint16_t* satz)
        {
            for(int k=0;k<PANZ;k++)
            {     
                satz[k]=0;        
                for(int i=0;i<16;i++)
                {                   
                    if(zufall(0,100)>50)
                    {
                        satz[k] |= (best1[k] & (1<<i));
                    }
                    else
                    {
                        satz[k] |= (best2[k] & (1<<i));                           
                    }            
                }     
            }    
        }

        void kontrollausgabe()
        {
                //Vorbereitung der Kontrollausgabe
                for(int k=0;k<PANZ;k++)
                {
                    paramtest->param.u[k] = psatz[bestindex[0]][k];
                    paramtest->param.aktualisiereDouble(k);            
                }
                //Kontrollausgabe
                cout<<"Kleinster Fehler = "<<bestfehler[0]<<endl;
                for(int k=0;k<PANZ;k++)
                    cout<<"Param Nr."<<k<<" = "<<*(paramtest->param.p[k])<<endl;                    
        }

        void optimieren(int schritte=100)
        {
            //1. Fehler bei allen Parameterstzen bestimmen
            for(int i=0;i<ANZAHL_DNA;i++)
            {
                for(int k=0;k<PANZ;k++)            
                    psatz[i][k] = paramtest->param.u[k];
        
                mutieren(psatz[i]);
        
                fehler[i] = paramtest->berechneFehler(psatz[i]);
            }
            
            //Mehrere Generationen durchrechnen.
            for(int schritt=0;schritt<schritte;schritt++)
            {
                //ANZAHL_BESTE Beste finden:
                for(int i=0;i<ANZAHL_BESTE;i++)
                {
                    bestfehler[i] = fehler[0];
                    bestindex[i] = 0;
                }    
                for(int i=0;i<ANZAHL_DNA;i++)
                {
                    if( (fehler[i]<=bestfehler[0] && fehler[i]>0.0)
                       || bestfehler[0]<0.0
                    )
                    {
                        for(int p=ANZAHL_BESTE-1;p>=1;p--)
                        {
                            bestfehler[p] = bestfehler[p-1];
                            bestindex[p] = bestindex[p-1];
                        }                               
                        bestfehler[0]=fehler[i];
                        bestindex[0]=i;                
                    }            
                }                     

                kontrollausgabe();
    
                //2. Beste merken
                for(int i=0;i<10;i++)
                    for(int k=0;k<PANZ;k++)            
                        psatzbest[i][k] = psatz[bestindex[i]][k];            

                //3. rekombinieren
                for(int i=ANZAHL_BESTE;i<ANZAHL_DNA;i++)
                {
                    rekombinieren(psatzbest[zufall(0,ANZAHL_BESTE-1)],psatzbest[zufall(0,ANZAHL_BESTE-1)],psatz[i]);
                    if(zufall(0,999)<MUTATIONSRATE)
                        mutieren(psatz[i]);            
                }    

                //4. Beste zurckschreiben
                for(int i=0;i<ANZAHL_BESTE;i++)
                {
                    for(int k=0;k<PANZ;k++)            
                        psatz[i][k]=psatzbest[i][k];            
                }
               //5. Fehler bei allen Parameterstzen bestimmen
                for(int i=0;i<ANZAHL_DNA;i++)
                    fehler[i] = paramtest->berechneFehler(psatz[i]);
                
            }    
        }
};

