class ModellRegelkreis : public Modell
{
    private:
        double w,de,ie,u;
    public:
        double K,T,d,P,I,D,pwm,e;

        ModellRegelkreis() : Modell(3)  
        {
            K=30.552649;
            T=0.0255439;
            d=2.0995919;

            P=800.0;
            I=100.0;
            D=0.001;
        }
        double rechteSeite(double* y, int zeile)
        {
            w  = 20;          //Sollwert in Omega_vierteln-Einheiten
            e  = w-y[0];    //Regeldifferenz
            de = -y[1];     //Fr konstantes w ist dies die Ableitung der Regeldifferenz
            ie =  y[2];     //Integral der Regelabweichung

            pwm = P*e + I*ie + D*de;
            u=pwm/1023;

            switch(zeile)
            {
                case 0:
                     return y[1];
                break;
                case 1:
                     return -(1/(T*T))*y[0]-(2.0*d/T)*y[1]+(K/(T*T))*u;
                break;                    
                default:
                     return e;
                break;                                                                                            
            }               
        }
}; 
