#define PANZ 3

class Param
{
    public:
        double*   p[PANZ];    //Array mit Zeigern auf die registrierten double-Parameter.
        double    pmin[PANZ]; //Minimaler Wert jedes Parameters.
        double    pmax[PANZ]; //Maximaler Wert jedes Parameters.

        uint16_t  u[PANZ];    //Integer-Reprsentation der einzelnen Parameter.

        void aktualisiereInt(int nr) //double-Reprsentation des ausgewhlten Parameters auf die Integer-Rep. bertragen.
        {
            u[nr] = (uint16_t)(  ((*p[nr]-pmin[nr])*65535.0)/(pmax[nr]-pmin[nr])  );
        }

        void aktualisiereDouble(int nr) //int-Reprsentation des ausgewhlten Parameters auf die double-Rep. bertragen.
        {
            *p[nr] = pmin[nr] + ((double)u[nr]*(pmax[nr]-pmin[nr]))/65535.0;
        }

        void registriere(int nr,double* x, double xmin, double xmax) //Neuen Parameter merken
        {
            p[nr]    = x;
            pmin[nr] = xmin;
            pmax[nr] = xmax;

            aktualisiereInt(nr);
        }        

        bool aendereDefinitionsbereich(int nr, double xmin_neu, double xmax_neu)
        {
            if(*p[nr]<xmin_neu || *p[nr]>xmax_neu)
                return false;

            pmin[nr] = xmin_neu;
            pmax[nr] = xmax_neu;
            aktualisiereInt(nr);
            return true;          
        }
};


