class ParamtestModell : public Paramtest
{
    private:
        ModellRegelkreis  modell;
        IntegratorRuKu    integrator;

    public:
        ParamtestModell()
        {
            integrator.registriereModell(&modell);
            //Die Modellparameter werden in param registriert, indem deren Zeiger 
            //in param.p gespeichert werden.
            //Ausserdem: Angabe des Definitionsbereiches jedes Parameters.
            param.registriere(0,&(modell.P),0.0,1000.0);
            param.registriere(1,&(modell.I),50.0,650.0);
            param.registriere(2,&(modell.D),-100.0,100.0);
        }


        double berechneFehler(uint16_t* psatz_akt) //liefert -1 wenn ungltige Parameterkombination
        {
            //double-Werte aus Integer-Reprsentation gewinnen:    
            for(int k=0;k<PANZ;k++)
            {
               param.u[k] = psatz_akt[k];                                  
               param.aktualisiereDouble(k);
            }                              
            
            //Simulation zur Bestimmung des aktuellen Fehlers durchfhren:
            double t=0.0;
            double dt=0.001;
            double* yneu;
            double yalt[3] = {0.0,0.0,0.0};
    
            double fehler = 0.0;
    
            for(int i=0;i<2000;i++)
            {
                yneu = integrator.zeitschritt(yalt,dt);
                yalt[0] = yneu[0];
                yalt[1] = yneu[1];
                yalt[2] = yneu[2];
                t=t+dt;
         
                if(modell.pwm >1023.0)
                    return -1.0;
            
                fehler+= fabs(modell.e);
                if(fehler > 5.10839e+223)
                    return fehler;
            }
            return fehler;
        }
};
