K=30.552649
T=0.0255439
d=2.0995919

P=51.1
I=0.768
D=335.35

global K,T,d, P,I,D;

function f = rechteSeite(t,y)    
    w  = 20;          //Sollwert in Omega_vierteln-Einheiten
    e  = w-y(1,1);    //Regeldifferenz
    de = -y(2,1);     //Fr konstantes w ist dies die Ableitung der Regeldifferenz
    ie =  y(3,1);     //Integral der Regelabweichung

    pwm = P*e + I*de + D*ie;
    u=pwm/1023;
    f(1,1) =  y(2,1);
    f(2,1) = -(1/T^2)*y(1,1)-(2.0*d/T)*y(2,1)+(K/T^2)*u;
    f(3,1) = e;  //y(3,1) ist damit das Integral der Regelabweichung.
endfunction

t = 0:0.001:0.45;
y0 = [0,0,0]';
t0 = 0;
y  = ode(y0,t0,t,rechteSeite);

plot(t,y(1,:)');

//Rekonstruktion der PWM-Werte aus dem Verlauf der Zustandsgren:
//(Deren Verlauf lt sich leider nicht direkt aus der Simulation herauslesen)
w  = 20;          //Sollwert in Omega_vierteln-Einheiten
e  = w-y(1,:);    //Regeldifferenz
de = -y(2,:);     //Fr konstantes w ist dies die Ableitung der Regeldifferenz
ie =  y(3,:);     //Integral der Regelabweichung
pwm = P*e + I*de + D*ie;
//plot(t,pwm);